<?php
namespace Ep\TecDoc;

use Ep\TecDoc\Hydrator\AbstractRecordSeqHydratorFactory;
use Ep\TecDoc\Hydrator\AbstractResponseHydratorFactory;
use Ep\TecDoc\Hydrator\DeepReflectionHydrator;
use Zend\Hydrator\Reflection as ReflectionHydrator;
use Zend\ServiceManager\AbstractFactory\ReflectionBasedAbstractFactory;
use Zend\ServiceManager\Factory\InvokableFactory;

return [
    'hydrators' => [
        'aliases' => [
            Record\AxleByCarIdRecord::class                 => ReflectionHydrator::class,
            Record\CabsByCarIdRecord::class                 => ReflectionHydrator::class,
            Record\KbaNumbersByVehicleIdRecord::class       => ReflectionHydrator::class,
            Record\ManufacturersRecord::class               => ReflectionHydrator::class,
            Record\ModelSeriesRecord::class                 => ReflectionHydrator::class,
            Record\MotorCodesByCarIdRecord::class           => ReflectionHydrator::class,
            Record\SecondaryTypesByCarIdRecord::class       => ReflectionHydrator::class,
            Record\VehicleByIdRecord::class                 => ReflectionHydrator::class,
            Record\VehicleByIds4Record::class               => DeepReflectionHydrator::class,
            Record\VehicleIdsByCriteriaRecord::class        => ReflectionHydrator::class,
            Record\VehiclePrototypeRecord::class            => ReflectionHydrator::class,
            Record\VehicleRegistrationInfoByIdRecord::class => ReflectionHydrator::class,
            Record\WheelBasesByCarIdRecord::class           => ReflectionHydrator::class,
        ],

        'factories' => [
            ReflectionHydrator::class     => InvokableFactory::class,
            DeepReflectionHydrator::class => ReflectionBasedAbstractFactory::class,

//            Record\VehicleByIds4Record::class               => Hydrator\VehicleByIds4RecordHydratorFactory::class,

            Record\Seq\AxleByCarIdRecordSeq::class           => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\CabsByCarIdRecordSeq::class           => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\KbaNumbersByVehicleIdRecordSeq::class => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\ManufacturersRecordSeq::class         => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\ModelSeriesRecordSeq::class           => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\MotorCodesByCarIdRecordSeq::class     => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\SecondaryTypesByCarIdRecordSeq::class => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\VehicleByIds4RecordSeq::class         => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\VehicleIdsByCriteriaRecordSeq::class  => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\VehiclePrototypeRecordSeq::class      => AbstractRecordSeqHydratorFactory::class,
            Record\Seq\WheelBasesByCarIdRecordSeq::class     => AbstractRecordSeqHydratorFactory::class,

            Response\ManufacturersResponse::class        => AbstractResponseHydratorFactory::class,
            Response\ModelSeriesResponse::class          => AbstractResponseHydratorFactory::class,
            Response\VehicleByIds4Response::class        => AbstractResponseHydratorFactory::class,
            Response\VehicleIdsByCriteriaResponse::class => AbstractResponseHydratorFactory::class,
        ],
    ],
];