<?php
namespace Ep\TecDoc\Middleware;

use Ep\TecDoc\TecDoc;
use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Zend\Stratigility\MiddlewarePipe;
use Zend\Stratigility\MiddlewarePipeInterface;
use function Zend\Stratigility\path;
use Zend\View\Renderer\RendererInterface;

class TecDocMiddleware implements MiddlewarePipeInterface
{
    /** @var MiddlewarePipeInterface */
    protected $pipeline;

    /**
     * TecDocMiddleware constructor.
     *
     * @param TecDoc $tecdoc
     */
    public function __construct(ContainerInterface $container)
    {
        $this->pipeline = new MiddlewarePipe();

        $tecdoc = $container->get('tecdoc_service');
        $renderer = $container->get(RendererInterface::class);

        $this->pipeline->pipe(path('/vehicle-select', new VehicleSelect($container)));
    }

    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        return $this->pipeline->process($request, $handler);
    }

    public function pipe(MiddlewareInterface $middleware): void
    {
        $this->pipeline->pipe($middleware);
    }

    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        return $this->pipeline->handle($request);
    }
}