<?php
namespace Ep\TecDoc\Plugin;

use Ep\Wp\Plugin\PluginInterface;

/**
 * Class TecDocCategory
 *
 * @package Ep\TecDoc\Plugin
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class TecDocCategory extends AbstractTecDocPlugin
{
    public function __invoke(): void
    {
        add_filter('term_link', [$this, 'term_link'], 10, 3);
    }

    public function term_link($url, $term, $taxonomy)
    {
        if ($taxonomy === 'product_cat' && ($vehicle = $this->tecdoc->getSelectedVehicle())) {
            $homeUrl = rtrim(get_option('home'), '/');

            if (empty($homeUrl)) {
                $url = '/' . $vehicle['slug'] . '/' . ltrim($url, '/');
            } else {
                $url = str_replace($homeUrl, $homeUrl . '/' . $vehicle['slug'], $url);
            }
        }

        return $url;
    }
}