<?php
namespace Ep\TecDoc\Plugin;

use Ep\Wp\Plugin\PluginInterface;

/**
 * Class Translations
 *
 * @package Ep\TecDoc\Plugin
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class Translations implements PluginInterface
{
    /**
     * Dodaje akcije i filtere u WordPress.
     *
     * @return void
     */
    public function __invoke(): void
    {
        add_action('wp_footer', [$this, 'wp_footer']);
    }

    public function wp_footer()
    {
        $translations = json_encode([
            'Featured Manufacturers' => __('Featured Manufacturers', 'ep-tecdoc'),
            'All Manufacturers' => __('All Manufacturers', 'ep-tecdoc'),
        ]);

        echo <<< EOS
<script>
    var tecdocTranslations = {$translations};
</script>
EOS;
    }
}