<?php
namespace Ep\TecDoc\Record\Seq;

use ArrayIterator;
use Countable;
use Traversable;

/**
 * Class AbstractRecordSeq
 *
 * @package Ep\TecDoc\Record\Seq
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
abstract class AbstractRecordSeq implements RecordSeqInterface
{
    /** @var array */
    protected $array;
    /** @var boolean */
    protected $empty;

    /**
     * @return int
     */
    public function count()
    {
        return count($this->array);
    }

    /**
     * @return array
     */
    public function getArray(): array
    {
        return $this->array;
    }

    /**
     * @return bool
     */
    public function isEmpty(): bool
    {
        return $this->empty;
    }

    /**
     * Retrieve an external iterator
     * @link http://php.net/manual/en/iteratoraggregate.getiterator.php
     * @return Traversable An instance of an object implementing <b>Iterator</b> or
     * <b>Traversable</b>
     * @since 5.0.0
     */
    public function getIterator()
    {
        return new ArrayIterator($this->array);
    }
}