<?php
namespace Ep\TecDoc\Request;

use Ep\TecDoc\Response\ModelSeriesResponse;

/**
 * Class ModelSeriesRequest
 *
 * @package Ep\TecDoc\Request
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class ModelSeriesRequest extends AbstractRequest
{
    use Parts\CountryTrait;
    use Parts\CountryGroupFlagTrait;
    use Parts\FavouredListTrait;
    use Parts\LangTrait;
    use Parts\LinkingTargetTypeTrait;

    /** @var string */
    protected $responseClass = ModelSeriesResponse::class;
    /** @var string */
    protected $remoteFunctionName = 'getModelSeries';
    /** @var int */
    protected $manuId;

    /**
     * @return int
     */
    public function getManuId(): int
    {
        return $this->manuId;
    }

    /**
     * @param int $manuId
     */
    public function setManuId(int $manuId): void
    {
        $this->manuId = $manuId;
    }
}
