<?php
namespace Ep\TecDoc\View;

use Ep\TecDoc\TecDocInterface;
use Ep\Wp\View\AbstractView;
use Zend\View\Renderer\RendererInterface;

/**
 * Class VehicleSelect
 *
 * @package Ep\TecDoc\View
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleSelect extends AbstractView
{
    /** @var TecDocInterface */
    protected $tecdoc;
    /** @var RendererInterface */
    protected $renderer;

    /**
     * VehicleSelect constructor.
     *
     * @param TecDocInterface $tecdoc
     * @param RendererInterface $renderer
     */
    public function __construct(TecDocInterface $tecdoc, RendererInterface $renderer)
    {
        $this->tecdoc   = $tecdoc;
        $this->renderer = $renderer;
    }

    /**
     * Dodaje akcije i filtere u WordPress.
     */
    public function init(): void
    {
        add_shortcode('tecdoc_vehicle_select', [$this, 'render']);
    }

    /**
     * Renderira view.
     *
     * @return string
     */
    public function render(): string
    {
        $logo_src = function_exists('get_theme_mod')
            ? get_theme_mod('site_logo')
            : false;

        return $this->renderer->render('@tecdoc/vehicle-select/index.html.twig', [
            'current' => $this->tecdoc->getCurrentVehicle(),
            'logo_src' => $logo_src,
        ]);
    }
}