<?php
namespace EpTest\TecDoc;

use Ep\TecDoc\Record\Seq\RecordSeqInterface;
use Ep\TecDoc\Response\ManufacturersResponse;
use Ep\TecDoc\Response\ResponseInterface;
use Ep\TecDoc\TecDoc;
use PHPUnit\Framework\TestCase;

/**
 * Class TecDocTest
 *
 * @package EpTest\TecDoc
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class TecDocTest extends TestCase
{
    use TecDocAwareTrait;

    public function testGetManufacturersWorks()
    {
        $container = $this->createContainer();
        /** @var TecDoc $tecdoc */
        $tecdoc = $container->get('tecdoc_service');

        $manufacturers = $tecdoc->getManufacturers();

        $this->assertInstanceOf(ManufacturersResponse::class, $manufacturers);
        $this->assertTrue(count($manufacturers) > 0);
    }
}